#include <streamer/streamer.h>

void main(int argc,char *argv[]) {
  StreamBufferPool *pool, *datapool;
  StreamBuffer *buf[16];
  int i;

  Stream_init();

  pool = StreamBufferPool_create(2,0,0,0);

  for (i=0;i<4;i++) {
    buf[i] = StreamBuffer_create(pool);
    g_print("buffer %i is at %p\n",i,buf[i]);
    buf[i]->freefunc = StreamBuffer_nullfree;
  }
  g_print("\n");

  StreamBufferPool_autoresize(pool);
  g_print("\n");

  g_print("freeing buffer 2\n");
  StreamBuffer_free(buf[2]);
  g_print("buffer 2 freed\n");
  g_print("freeing buffer 3\n");
  StreamBuffer_free(buf[3]);
  g_print("buffer 3 freed\n");
  g_print("\n");

  for (i=2;i<6;i++) {
    buf[i] = StreamBuffer_create(pool);
    g_print("buffer %d is at %p\n",i,buf[i]);
    buf[i]->freefunc = StreamBuffer_nullfree;
  }
  g_print("\n");

  g_print("there are now %d elements in pool of %d\n",
          StreamBufferPool_getbufcount(pool),
          StreamBufferPool_getsize(pool));
  g_print("\n");

  g_print("freeing buffer 0\n");
  StreamBuffer_free(buf[0]);
  g_print("buffer 0 freed\n");
  g_print("freeing buffer 1\n");
  StreamBuffer_free(buf[1]);
  g_print("buffer 1 freed\n");
  g_print("\n");

  for (i=2;i<6;i++) {
    g_print("freeing buffer %d\n",i);
    StreamBuffer_free(buf[i]);
    g_print("buffer %d freed\n",i);
  }
  g_print("\n");

  for (i=0;i<12;i++) {
    buf[i] = StreamBuffer_create(pool);
    g_print("buffer %d is at %p\n",i,buf[i]);
    buf[i]->freefunc = StreamBuffer_nullfree;
  }
  g_print("\n");


  datapool = StreamBufferPool_create(16,0,0,4096);
  g_print("allocated pool of 16 buffers with 4K data\n");

  return;
}
