/* 
 * elem_play.h --
 *
 *	Defines the upper-level decoders that act on a video file
 *	for controlled decoding.
 *
 */

#ifndef ELEM_PLAY_H
#define ELEM_PLAY_H

#include "global.h"
#include "video.h"
#include "readfile.h"


#define VID_START	1
#define VID_END		2
#define VID_GOP		3
#define VID_FRAME	4

typedef BOOLEAN ParseCallback(long fpos, int type, void *data, void *ref);


/*** Function prototypes ***/

BOOLEAN mpegVidParse(DataStream *data_stream, ParseCallback *callback, void *ref);
BOOLEAN mpegVidStart(DataStream *data_stream, VidDecoder *vid_decoder, XInfo *xinfo);
BOOLEAN mpegVidGoP(DataStream *data_stream, VidDecoder *vid_decoder);
BOOLEAN mpegVidFrame(DataStream *data_stream, VidDecoder *vid_decoder, PictImage *destImage, PictImage *pastImage, PictImage *futureImage);

#endif /* ELEM_PLAY_H */
