#ifndef STREAMER_PLUGINS_H
#define STREAMER_PLUGINS_H

#include <streamer/streamer.h>

struct _StreamPlugin {
  gchar *filename;
  GModule *module;

  gchar *name;
  gchar *longname;
  gchar *version;

  GSList *elementtypes;

  void (*initfunc)(StreamPlugin *);

  /* some functions used by normal users */
  StreamElementType *(*enumtypes)(int idx);
};

StreamPlugin *StreamPlugin_load(gchar *name);
gchar *StreamPlugin_getname(StreamPlugin *plugin);
gboolean _StreamPlugin_matchbyname(gconstpointer a, gconstpointer b);
StreamElementType *StreamPlugin_enumtypes(StreamPlugin *plugin,int idx);

#endif /* STREAMER_PLUGINS_H */
